libstdc++: std::__debug::multimap< _Key, _Tp, _Compare, _Allocator > Class Template Reference

libstdc++

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator > Class Template Reference

`#include <multimap.h>`

Inheritance diagram for std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >:
[legend]

## Public Types
typedef _Allocator | allocator_type
typedef __gnu_debug::_Safe_iterator< _Base_const_iterator, multimap > | const_iterator
typedef _Base::const_pointer | const_pointer
typedef _Base::const_reference | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef _Base::difference_type | difference_type
typedef __gnu_debug::_Safe_iterator< _Base_iterator, multimap > | iterator
typedef _Compare | key_compare
typedef _Key | key_type
typedef _Tp | mapped_type
typedef _Base::pointer | pointer
typedef _Base::reference | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef _Base::size_type | size_type
typedef std::pair< const _Key, _Tp > | value_type

## Public Member Functions
| multimap (_Base_ref __x)
template<typename _InputIterator>
| multimap (_InputIterator __first, _InputIterator __last, const _Compare &__comp=_Compare(), const _Allocator &__a=_Allocator())
template<typename _InputIterator>
| multimap (_InputIterator __first, _InputIterator __last, const allocator_type &__a)
| multimap (const _Compare &__comp, const _Allocator &__a=_Allocator())
| multimap (const allocator_type &__a)
| multimap (const multimap &)=default
| multimap (const multimap &__m, const __type_identity_t< allocator_type > &__a)
| multimap (initializer_list< value_type > __l, const _Compare &__c=_Compare(), const allocator_type &__a=allocator_type())
| multimap (initializer_list< value_type > __l, const allocator_type &__a)
| multimap (multimap &&)=default
| multimap (multimap &&__m, const __type_identity_t< allocator_type > &__a) noexcept(noexcept(_Base(std::move(__m), __a)))
const _Base & | _M_base () const noexcept
_Base & | _M_base () noexcept
const_iterator | begin () const noexcept
iterator | begin () noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
template<typename... _Args>
iterator | emplace (_Args &&... __args)
template<typename... _Args>
iterator | emplace_hint (const_iterator __pos, _Args &&... __args)
const_iterator | end () const noexcept
iterator | end () noexcept
std::pair< iterator, iterator > | equal_range (const key_type &__x)
std::pair< const_iterator, const_iterator > | equal_range (const key_type &__x) const
_Base_iterator | erase (_Base_const_iterator __position)
template<__heterogeneous_tree_key< multimap > _Kt>
size_type | erase (_Kt &&__x)
size_type | erase (const key_type &__x)
iterator | erase (const_iterator __first, const_iterator __last)
iterator | erase (const_iterator __position)
iterator | erase (iterator __position)
iterator | find (const key_type &__x)
const_iterator | find (const key_type &__x) const
template<typename _InputIterator>
void | insert (_InputIterator __first, _InputIterator __last)
template<typename _Pair, typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type>
iterator | insert (_Pair &&__x)
iterator | insert (const value_type &__x)
template<typename _Pair, typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type>
iterator | insert (const_iterator __position, _Pair &&__x)
iterator | insert (const_iterator __position, const value_type &__x)
iterator | insert (const_iterator __position, value_type &&__x)
void | insert (std::initializer_list< value_type > __list)
iterator | insert (value_type &&__x)
iterator | lower_bound (const key_type &__x)
const_iterator | lower_bound (const key_type &__x) const
multimap & | operator= (const multimap &)=default
multimap & | operator= (initializer_list< value_type > __l)
multimap & | operator= (multimap &&)=default
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rbegin () noexcept
const_reverse_iterator | rend () const noexcept
reverse_iterator | rend () noexcept
void | swap (multimap &__x) noexcept(/*conditional */)
iterator | upper_bound (const key_type &__x)
const_iterator | upper_bound (const key_type &__x) const

## Protected Member Functions
constexpr void | _M_swap (const _Safe_container &__x) const noexcept

## Friends
template<typename _ItT, typename _SeqT, typename _CatT>
class | ::__gnu_debug::_Safe_iterator

## Detailed Description

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
class std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >

Class std::multimap with safety/checking/debug instrumentation.

Definition at line 44 of file multimap.h.

## Member Typedef Documentation

## ◆ allocator_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Allocator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::allocator_type

Definition at line 78 of file multimap.h.

## ◆ const_iterator

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef __gnu_debug::_Safe_iterator<_Base_const_iterator, multimap> std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::const_iterator

Definition at line 85 of file multimap.h.

## ◆ const_pointer

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::const_pointer std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::const_pointer

Definition at line 90 of file multimap.h.

## ◆ const_reference

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::const_reference std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::const_reference

Definition at line 80 of file multimap.h.

## ◆ const_reverse_iterator

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef std::reverse_iterator<const_iterator> std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::const_reverse_iterator

Definition at line 92 of file multimap.h.

## ◆ difference_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::difference_type std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::difference_type

Definition at line 88 of file multimap.h.

## ◆ iterator

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef __gnu_debug::_Safe_iterator<_Base_iterator, multimap> std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::iterator

Definition at line 83 of file multimap.h.

## ◆ key_compare

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Compare std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::key_compare

Definition at line 77 of file multimap.h.

## ◆ key_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Key std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::key_type

Definition at line 74 of file multimap.h.

## ◆ mapped_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Tp std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::mapped_type

Definition at line 75 of file multimap.h.

## ◆ pointer

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::pointer std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::pointer

Definition at line 89 of file multimap.h.

## ◆ reference

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::reference std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::reference

Definition at line 79 of file multimap.h.

## ◆ reverse_iterator

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef std::reverse_iterator<iterator> std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::reverse_iterator

Definition at line 91 of file multimap.h.

## ◆ size_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::size_type std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::size_type

Definition at line 87 of file multimap.h.

## ◆ value_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef std::pair<const _Key, _Tp> std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::value_type

Definition at line 76 of file multimap.h.

## Constructor & Destructor Documentation

## ◆ multimap() [1/9]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::multimap | ( | initializer_list< value_type > | __l,
|  | const _Compare & | __c = _Compare(),
|  | const allocator_type & | __a = allocator_type() )
| inline

Definition at line 108 of file multimap.h.

## ◆ multimap() [2/9]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::multimap | ( | const allocator_type & | __a | ) |
| inline explicit

Definition at line 114 of file multimap.h.

## ◆ multimap() [3/9]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::multimap | ( | const multimap< _Key, _Tp, _Compare, _Allocator > & | __m,
|  | const __type_identity_t< allocator_type > & | __a )
| inline

Definition at line 117 of file multimap.h.

## ◆ multimap() [4/9]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::multimap | ( | multimap< _Key, _Tp, _Compare, _Allocator > && | __m,
|  | const __type_identity_t< allocator_type > & | __a )
| inline noexcept

Definition at line 121 of file multimap.h.

## ◆ multimap() [5/9]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::multimap | ( | initializer_list< value_type > | __l,
|  | const allocator_type & | __a )
| inline

Definition at line 126 of file multimap.h.

## ◆ multimap() [6/9]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator>

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::multimap | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a )
| inline

Definition at line 130 of file multimap.h.

## ◆ multimap() [7/9]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::multimap | ( | const _Compare & | __comp,
|  | const _Allocator & | __a = _Allocator() )
| inline explicit

Definition at line 158 of file multimap.h.

## ◆ multimap() [8/9]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator>

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::multimap | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const _Compare & | __comp = _Compare(),
|  | const _Allocator & | __a = _Allocator() )
| inline

Definition at line 163 of file multimap.h.

## ◆ multimap() [9/9]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::multimap | ( | _Base_ref | __x | ) |
| inline

Definition at line 171 of file multimap.h.

## Member Function Documentation

## ◆ _M_base() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const _Base & std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::_M_base | ( |  | ) | const
| inline noexcept

Definition at line 637 of file multimap.h.

## ◆ _M_base() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

_Base & std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::_M_base | ( |  | ) |
| inline noexcept

Definition at line 634 of file multimap.h.

## ◆ _M_swap()

template<typename _SafeContainer, typename _Alloc, template< typename > class _SafeBase, bool _IsCxx11AllocatorAware = true>

void __gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware >::_M_swap | ( | const _Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware > & | __x | ) | const
| inline constexpr protected noexcept inherited

Definition at line 141 of file safe_container.h.

## ◆ begin() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::begin | ( |  | ) | const
| inline noexcept

Definition at line 198 of file multimap.h.

## ◆ begin() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::begin | ( |  | ) |
| inline noexcept

Definition at line 194 of file multimap.h.

## ◆ cbegin()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::cbegin | ( |  | ) | const
| inline noexcept

Definition at line 227 of file multimap.h.

## ◆ cend()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::cend | ( |  | ) | const
| inline noexcept

Definition at line 231 of file multimap.h.

## ◆ clear()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

void std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::clear | ( |  | ) |
| inline noexcept

Definition at line 500 of file multimap.h.

## ◆ crbegin()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::crbegin | ( |  | ) | const
| inline noexcept

Definition at line 235 of file multimap.h.

## ◆ crend()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::crend | ( |  | ) | const
| inline noexcept

Definition at line 239 of file multimap.h.

## ◆ emplace()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename... _Args>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::emplace | ( | _Args &&... | __args | ) |
| inline

Definition at line 252 of file multimap.h.

## ◆ emplace_hint()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename... _Args>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::emplace_hint | ( | const_iterator | __pos,
|  | _Args &&... | __args )
| inline

Definition at line 257 of file multimap.h.

## ◆ end() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::end | ( |  | ) | const
| inline noexcept

Definition at line 206 of file multimap.h.

## ◆ end() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::end | ( |  | ) |
| inline noexcept

Definition at line 202 of file multimap.h.

## ◆ equal_range() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::pair< iterator, iterator > std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::equal_range | ( | const key_type & | __x | ) |
| inline

Definition at line 592 of file multimap.h.

## ◆ equal_range() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::pair< const_iterator, const_iterator > std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::equal_range | ( | const key_type & | __x | ) | const
| inline

Definition at line 613 of file multimap.h.

## ◆ erase() [1/6]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

_Base_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::erase | ( | _Base_const_iterator | __position | ) |
| inline

Definition at line 398 of file multimap.h.

## ◆ erase() [2/6]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<__heterogeneous_tree_key< multimap > _Kt>

size_type std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::erase | ( | _Kt && | __x | ) |
| inline

Definition at line 438 of file multimap.h.

## ◆ erase() [3/6]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

size_type std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::erase | ( | const key_type & | __x | ) |
| inline

Definition at line 420 of file multimap.h.

## ◆ erase() [4/6]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::erase | ( | const_iterator | __first,
|  | const_iterator | __last )
| inline

Definition at line 454 of file multimap.h.

## ◆ erase() [5/6]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::erase | ( | const_iterator | __position | ) |
| inline

Definition at line 391 of file multimap.h.

## ◆ erase() [6/6]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::erase | ( | iterator | __position | ) |
| inline

Definition at line 407 of file multimap.h.

## ◆ find() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::find | ( | const key_type & | __x | ) |
| inline

Definition at line 512 of file multimap.h.

## ◆ find() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::find | ( | const key_type & | __x | ) | const
| inline

Definition at line 525 of file multimap.h.

## ◆ insert() [1/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator>

void std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inline

Definition at line 331 of file multimap.h.

## ◆ insert() [2/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Pair, typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::insert | ( | _Pair && | __x | ) |
| inline

Definition at line 283 of file multimap.h.

## ◆ insert() [3/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::insert | ( | const value_type & | __x | ) |
| inline

Definition at line 269 of file multimap.h.

## ◆ insert() [4/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Pair, typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::insert | ( | const_iterator | __position,
|  | _Pair && | __x )
| inline

Definition at line 318 of file multimap.h.

## ◆ insert() [5/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::insert | ( | const_iterator | __position,
|  | const value_type & | __x )
| inline

Definition at line 295 of file multimap.h.

## ◆ insert() [6/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::insert | ( | const_iterator | __position,
|  | value_type && | __x )
| inline

Definition at line 308 of file multimap.h.

## ◆ insert() [7/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

void std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::insert | ( | std::initializer_list< value_type > | __list | ) |
| inline

Definition at line 289 of file multimap.h.

## ◆ insert() [8/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::insert | ( | value_type && | __x | ) |
| inline

Definition at line 276 of file multimap.h.

## ◆ lower_bound() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::lower_bound | ( | const key_type & | __x | ) |
| inline

Definition at line 540 of file multimap.h.

## ◆ lower_bound() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::lower_bound | ( | const key_type & | __x | ) | const
| inline

Definition at line 553 of file multimap.h.

## ◆ operator=()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

multimap & std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::operator= | ( | initializer_list< value_type > | __l | ) |
| inline

Definition at line 182 of file multimap.h.

## ◆ rbegin() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::rbegin | ( |  | ) | const
| inline noexcept

Definition at line 214 of file multimap.h.

## ◆ rbegin() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

reverse_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::rbegin | ( |  | ) |
| inline noexcept

Definition at line 210 of file multimap.h.

## ◆ rend() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::rend | ( |  | ) | const
| inline noexcept

Definition at line 222 of file multimap.h.

## ◆ rend() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

reverse_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::rend | ( |  | ) |
| inline noexcept

Definition at line 218 of file multimap.h.

## ◆ swap()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

void std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::swap | ( | multimap< _Key, _Tp, _Compare, _Allocator > & | __x | ) |
| inline noexcept

Definition at line 492 of file multimap.h.

## ◆ upper_bound() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::upper_bound | ( | const key_type & | __x | ) |
| inline

Definition at line 566 of file multimap.h.

## ◆ upper_bound() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::upper_bound | ( | const key_type & | __x | ) | const
| inline

Definition at line 579 of file multimap.h.

## Friends And Related Symbol Documentation

## ◆ ::__gnu_debug::_Safe_iterator

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _ItT, typename _SeqT, typename _CatT>

friend class ::__gnu_debug::_Safe_iterator
| friend

Definition at line 60 of file multimap.h.

The documentation for this class was generated from the following file:

- multimap.h